; Ergnzende Kommentare zum Assembler-Programm KleinerFuchs.asm

; [K1] Quarz oder LED
; Wenn keine Quarzgenauigkeit fr den Senderhythmus gefordert ist, kann
; eine LED mit Vorwiderstand zwischen PB4 und GND geschaltet werden.
; Anderenfalls Quarz 8 MHz zwischen PB3 und PB4 schalten und die Fuses
; entsprechend setzen.

; [K2] Poti fr Senderhythmus
; Zur Einstellung des Senderhythmus dient ein lineares Potentiometer mit
; 100 bis 500 kOhm, das zwischen GND und VCC geschaltet wird, Schleifer
; an PB2 (= ADC1). Die Potistellung wird einmalig beim Programmstart
; abgefragt. Es werden 5 Bereiche unterschieden, um 0 bis 4 Minuten
; Sendeabstand einzustellen: 0 am GND-Anschlag, 2 bei Mittelstellung,
; 4 am VCC-Anschlag, 1 und 3 jeweils in der Mitte dazwischen.

; [K3] Timer/Counter 1 als innere Uhr
; Timer 1 liefert die Zeitbasis fr die Einhaltung des Minutenrhythmus.
; Er wird so langsam wie mglich getaktet, nmlich mit Systemtakt 8 MHz
; geteilt durch 16384, also 488,28125 Hz. TCNT1 zhlt zyklisch von 0 bis
; 234 (= OCR1C) und erzeugt bei berlauf einen Interrupt, d. h. alle
; 0,48128 Sekunden. Die Lnge einer Minute ergibt sich mit hoher Genau-
; igkeit als das (124 2/3)fache dieses Intervalls.

; [K4] Timer/Counter 0 zur Audiosignalerzeugung
; Um die gesamte Schaltung klein halten zu knnen, wird das Audiosignal
; durch Pulsweitenmodulation erzeugt. T/C 0 arbeitet hierzu im Modus
; "Fast PWM" (mode 3). Timertakt = 8 MHz, Auflsung 8 bit. =>
; DAC-Takt = 8 MHz / 256 = 31250 Hz. Jedes Sample wird 4mal ausgegeben
; (daher minimal gedehnt, da Samplerate = 8 KHz).

; [K5] Frequenz und Geschwindigkeit der Morsezeichen
; Auch zur Erzeugung der Morse-Tonfrequenz wird T/C 0 eingesetzt. Er
; wird hierzu mit Systemtakt / 256 = 31250 Hz getaktet. Der Timer zhlt
; zyklisch von 0 bis OCR0A; auf halber Strecke wird das Signal OC0B an
; Port PB1 umgeschaltet (Fast PWM, mode 7).
; Die ersten beiden Bytes im EEPROM x1 und x2 legen Frequenz und
; Geschwindigkeit der erzeugten Morsezeichen fest.
;
; x1 (1 bis 255) wird in OCR0A geschrieben. Daher:
; Frequenz f = 31250 / (x1 + 1) Hz  |  x1 = 31250 / f - 1
; Bsp.: ca. 600 Hz bei x1 = 51
;
; x2 geht als Faktor in die Lnge von Punkt (dit) und Strich (dah) ein;
; ein dit besteht aus 4 * x2 Tonperioden. Ist g die Morsegeschwindigkeit
; in Zeichen pro Minute, so errechnet sich x2 = 43200 / [g * (x1 + 1)].
; Bsp.: 600 Hz, 30 Zeichen pro Minute: x2 = 21
; Empirisch ermittelte ca.-Werte!


; Autor:  Dr. Michael Schramm, Bordesholm
