; Makros fr AVR-Assemblerprogramme
; Dr. Michael Schramm Softwareentwicklung
; www.schramm-software.de

.macro ld_i ;(reg, 8bit-Zahl) - LDI-Ersatz fr R0-R15, zerstrt R16
  ldi r16,@1
  mov @0,r16
.endmacro

.macro ldi_hl ;(reg, 16bit-Zahl)
  ldi @0h,high(@1)
  ldi @0l,low(@1)
.endmacro

.macro out_i ;(I/O-reg, 8bit-Zahl) - zerstrt Inhalt von R16
  ldi r16,@1
 .if @0 < 64
  out @0,r16
 .else
  sts @0,r16
 .endif
.endmacro

.macro push_hl
  push @0h
  push @0l
.endmacro

.macro pop_hl
  pop @0l
  pop @0h
.endmacro

.macro for ;(reg, anzahl bzw. startwert, label); fr reg ab R16
  ldi @0,@1
  .set @2 = pc
.endmacro

.macro next_down ;(reg, label)
  dec @0
.if pc-@1 < 64
  brne @1
.else
  breq pc+2
  rjmp @1
.endif
.endmacro

.macro next_up ;(reg, endwert, label)
  inc @0
  cpi @0,@1
.if pc-@1 < 64
  brne @2
.else
  breq pc+2
  rjmp @2
.endif
.endmacro

.macro loop ;(label, reg) - Register muss vorbelegt sein
  .set @0 = pc
.endmacro

.macro sleep_idle
  out_i MCUCR,(1<<SE)
  sleep
.endmacro

.macro sleep_adc
  out_i MCUCR,(1<<SE)+(1<<SM0) ;ADC-Noise-Reduction-Modus
  sleep
.endmacro

